import QtQuick 1.1
import "../imports/XAComponents"
import "../Map"

Item {
    id: maincomponent

    property int itemProgress: 0

    property string itemRACIRescponsibleHR: ""
    property string itemRACIAccountableHR: ""
    property string itemRACIConsultedHR: ""
    property string itemRACIInformedHR: ""

    property string itemCreationDTSHR: ""

    property bool isEditable: false

    property bool isEditing: false
    property bool isModified: false
    property bool isSelected: false

    property int inputInset: 12

    signal displayDatePickerAt(string field, int x, int y);
    signal displayContextPickerAt(string contextType, int x, int y);
    signal progressUpdated(int newProgress);

    property Gradient backgroundGradient: Gradient {
        GradientStop { position: 0.0; color: "white" }
        GradientStop { position: 1.0; color: "#d9d9d9" }
    }

    Rectangle {
        id: background
        anchors.fill: parent
        color: "transparent"

        AIActionDetailsLineInput {
            id: progressInput
            anchors { left: parent.left; leftMargin: maincomponent.inputInset; right: parent.right; rightMargin:maincomponent.inputInset; top: parent.top; topMargin: 6 }
            height: 21

            itemLabelText: qsTr("Progress (%):")
            lineInputType: 0
            itemText: maincomponent.itemProgress

            onTextUpdated: {
                //console.debug("Progress in More Panel changed to: ")
                //console.debug(newText)
                progressUpdated(newText)
            }

            onItemClicked: {
                console.debug("progressInput clicked - closing Picker")
                QtHandler.closeAllPicker();
            }
        }

        AIActionDetailsLineInput {
            id: raciResponsibleInput
            anchors { left: parent.left; leftMargin: maincomponent.inputInset; right: parent.right; rightMargin:maincomponent.inputInset; top: progressInput.bottom; topMargin: 18 }
            height: 21

            itemLabelText: qsTr("Responsible:")
            lineInputType: 2
            itemText: maincomponent.itemRACIRescponsibleHR
            contextInputType: "R"

            onDisplayContextPickerAt: {
                //console.debug("Context Picker requested in More Panel")
                //maincomponent.displayContextPickerAt(contextType, 446, 270)
                maincomponent.displayContextPickerAt(contextType, 446, raciResponsibleInput.y + 105)
            }
        }

        AIActionDetailsLineInput {
            id: raciAccountableInput
            anchors { left: parent.left; leftMargin: maincomponent.inputInset; right: parent.right; rightMargin:maincomponent.inputInset; top: raciResponsibleInput.bottom; topMargin: 6 }
            height: 21

            itemLabelText: qsTr("Accountable:")
            lineInputType: 2
            itemText: maincomponent.itemRACIAccountableHR
            contextInputType: "A"

            onDisplayContextPickerAt: {
                //console.debug("Context Picker requested in More Panel")
                //maincomponent.displayContextPickerAt(contextType, 446, 297)
                maincomponent.displayContextPickerAt(contextType, 446, raciAccountableInput.y + 105)
            }
        }

        AIActionDetailsLineInput {
            id: raciConsultedInput
            anchors { left: parent.left; leftMargin: maincomponent.inputInset; right: parent.right; rightMargin:maincomponent.inputInset; top: raciAccountableInput.bottom; topMargin: 6 }
            height: 21

            itemLabelText: qsTr("Consulted:")
            lineInputType: 2
            itemText: maincomponent.itemRACIConsultedHR
            contextInputType: "C"

            onDisplayContextPickerAt: {
                //console.debug("Context Picker requested in More Panel")
                //maincomponent.displayContextPickerAt(contextType, 446, 324)
                maincomponent.displayContextPickerAt(contextType, 446, raciConsultedInput.y + 105)
            }
        }

        AIActionDetailsLineInput {
            id: raciInformedInput
            anchors { left: parent.left; leftMargin: maincomponent.inputInset; right: parent.right; rightMargin:maincomponent.inputInset; top: raciConsultedInput.bottom; topMargin: 6 }
            height: 21

            itemLabelText: qsTr("Informed:")
            lineInputType: 2
            itemText: maincomponent.itemRACIInformedHR
            contextInputType: "I"

            onDisplayContextPickerAt: {
                //console.debug("Context Picker requested in More Panel")
                //maincomponent.displayContextPickerAt(contextType, 446, 351)
                maincomponent.displayContextPickerAt(contextType, 446, raciInformedInput.y + 105)
            }
        }


    }
}
